#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>

float 	d;
float 	**z;
float 	xl, yl;
int 	m, n;
				/*parabola - ellipse */
float 	hx1, hx2, hy1, hy2;
				/*linear - triangle*/
float 	ang1, ang2, ang3, ang4;

float 	radius;

int 	tc;
int 	t_s;
char	*mat, *nam;

main(argc,argv)
int     argc;
char    *argv[];
{
char	*type_s;
int	i,im,in;

        if (argc < 9) {
		usage();
                exit();
        }

	type_s=argv[9];

	if(argv[3][0]=='s'||argv[3][0]=='S'){
		t_s=1; /* SURFACE TYPE */
	}
	else if(argv[3][0]=='w'||argv[3][0]=='W'){
		t_s=2; /* WIRE FRAME TYPE */
		radius=atof(argv[4]);
		if(radius == 0) radius=0.01; /* To prevent radius value of 0 */
	}
	else{
		usage();
                exit();
	}

	if(type_s[0]=='p'||type_s[0]=='P'){
		if (argc < 14) {
			usage();
                	exit();
        	}
		tc=1;
		hx1=atof(argv[10]);
		hx2=atof(argv[11]);
		hy1=atof(argv[12]);
		hy2=atof(argv[13]);
	}
	else if(type_s[0]=='e'||type_s[0]=='E'){
		if (argc < 14) {
			usage();
                	exit();
        	}
		tc=4;
		hx1=atof(argv[10]);
		hx2=atof(argv[11]);
		hy1=atof(argv[12]);
		hy2=atof(argv[13]);
	}
	else if(type_s[0]=='c'||type_s[0]=='C'){
		tc=3;
	}
	else if(type_s[0]=='l'||type_s[0]=='L'){
		if (argc < 12) {
			usage();
                	exit();
        	}
		tc=2;
		ang1=atof(argv[10]);
		ang2=atof(argv[11]);
	}
	else if(type_s[0]=='t'||type_s[0]=='T'){
		if (argc < 14) {
			usage();
                	exit();
        	}
		tc=5;
		ang1=atof(argv[10]);
		ang2=atof(argv[11]);
		ang3=atof(argv[12]);
		ang4=atof(argv[13]);
	}
	else{
		usage();
                exit();
	}

	mat=argv[1];
	nam=argv[2];
	xl=atof(argv[5]);
	yl=atof(argv[5]); /* To prevent length and wide be different */
/*	yl=atof(argv[6]);*/
	m=atoi(argv[7]);
	n=atoi(argv[7]); /* To prevent unequal number of divisions */
/*	n=atoi(argv[8]);*/

	im=m+1;
	in=n+1;
	z=(float **)malloc(sizeof(int*) * im);
	for(i=0;i<im;i++){
		z[i]=(float *)malloc(sizeof(int*) * in); 
	}

	d= xl / m ;

	if(tc==1)
		parabol();
	else if(tc==4)
		ellipse();
	else if(tc==2)
		linear();
	else if(tc==3)
		circles();
	else if(tc==5)
		triangle();

	calculation();
	torad();

        free(z);
}
/*____________________________________________________*/
calculation()
{
	int 	i, j, index, flag_con;
	float 	zinit= 0., sg= 0.001;
	float 	x, y, zo, dz, ardz, adzm;

	for(i = 1; i <= m-1; i = i + 1){
		for(j = 1; j <= n-1; j = j + 1){
			z[i][j] = zinit;
		}
	}
	for( index = 0; index <= 1000; index = index + 1){
		flag_con = 0;
		adzm = 0.;
		for(i = 1; i <= m-1; i = i + 1){
			for(j = 1; j <= n-1; j = j + 1){
				zo = z[i][j];
				z[i][j]=(z[i][j+1]+z[i][j-1]+
				    z[i-1][j]+z[i+1][j])*0.25;
				dz = z[i][j]-zo;
				ardz= fabs(dz / z[i][j]);
				if(ardz > adzm) adzm=ardz;
				if(ardz <= sg) continue;
				flag_con = 1;
			}
		}
		if(flag_con == 0)break;
	}
}
/*____________________________________________________*/
torad()
{
FILE *fp, *popen();
char combuf[128];
	float 	***vz;
	int 	i, j;
	int 	im, in,iz;
	float 	px, py, pz;

	im=m+1;
	in=n+1;
	iz=3;
	
	vz=(float ***)malloc(sizeof(int*) * im);
	for(i=0;i<im;i++){
		vz[i]=(float **)malloc(sizeof(int*) * in); 
		for(j=0;j<in;j++){
			vz[i][j]=(float *)malloc(sizeof(int*) * iz); 
		}
	}
	for(j = 0; j <= n; j = j + 1){
		for(i = 0; i <= m; i = i + 1){
			vz[i][j][0]= d * i;
			vz[i][j][1]= d * j;
			vz[i][j][2]= z[i][j];
		}
	}
	if(t_s == 1){
		sprintf(combuf, "gensurf %s %s - - - %d %d -s", mat, nam, m, n);
		if ((fp = popen(combuf, "w")) == NULL) {
/*			fprintf(stderr, "I'm hurt!  I'm bleeding!  I'm dying!\n");*/
			exit(1); 
		}
/*		write_xyz_points_to_stream(fp);*/

		for(j = 0; j <= n; j = j + 1){
			for(i = 0; i <= m; i = i + 1){
				px= d * i;
				pz= z[i][j];
				py= d * j;
				fprintf(fp,"%.3f %.3f %.3f\n", px,py,pz);
			}
		}
		fclose(fp);
	}
	else if(t_s == 2){
		for(j = 0; j <= n; j = j + 1){
			for(i = 0; i < m; i = i + 1){
				printf("%s cylinder %s.%d.%d.m 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
				mat,nam,j,i,vz[i][j][0],vz[i][j][1],vz[i][j][2],
				vz[i+1][j][0],vz[i+1][j][1],vz[i+1][j][2],radius);
			}
		}
		for(i = 0; i <= m; i = i + 1){
			for(j = 0; j < n; j = j + 1){
				printf("%s cylinder %s.%d.%d.n 0 0 7 %.3f %.3f %.3f %.3f %.3f %.3f %.3f\n",
				mat,nam,j,i,vz[i][j][0],vz[i][j][1],vz[i][j][2],
				vz[i][j+1][0],vz[i][j+1][1],vz[i][j+1][2],radius);
			}
		}
		for(j = 1; j < n; j = j + 1){
			for(i = 1; i < m; i = i + 1){
				printf("%s sphere %s.%d.%d.s 0 0 4 %.3f %.3f %.3f %.3f\n",
				mat,nam,j,i,vz[i][j][0],vz[i][j][1],vz[i][j][2],radius);
			}
		}
	}
}
/*____________________________________________________*/
parabol()
{
	int 	i, j;
	float 	x, y;
	float	par();

	for(i = 0; i <= m; i = i + 1){
		x= i * d;
		z[i][0] = par(x, xl, hx1);
		z[i][n] = par(x, xl, hx2);
	}
	for(j = 0; j <= n; j = j + 1){
		y = j * d;
		z[0][j] = par(y, yl, hy1);
		z[m][j] = par(y, yl, hy2);
	}
}
/*____________________________________________________*/
float par(s,sl,hm)
float s, sl, hm;
{
	float h;
	h = 4 * hm * s * (sl - s) / (sl * sl);
	return(h);
}
/*____________________________________________________*/
linear()
{
	int 	i, j;
	float x, y;
	float	rectan();

	for(i = 0; i <= m; i = i + 1){
		x= i * d;
		z[i][0] = rectan(x, ang1);
	}
	i=m;
	for(j = 0; j <= n; j = j + 1){
		z[m][j] = z[i][0];
		i=i-1;
	}
	for(j = 0; j <= n; j = j + 1){
		y= j * d;
		z[0][j] = rectan(y, ang2);
	}
	j=n;
	for(i = 0; i <= m; i = i + 1){
		z[i][n] = z[0][j];
		j=j-1;
	}
}
/*____________________________________________________*/
triangle()
{
	int 	i, j, l, km, kn;
	float 	x, y;
	float	rectan();

	km=m/2;
	for(i = 0; i <= km; i = i + 1){
		x= i * d;
		z[i][0] = rectan(x, ang1);
		z[i][n] = rectan(x, ang2);
	}
	i=km;
	for(l = km; l <= m; l = l + 1){
		z[l][0] = z[i][0];
		z[l][n] = z[i][n];
		i=i-1;
	}
	kn=n/2;
	for(j = 0; j <= kn; j = j + 1){
		y= j * d;
		z[0][j] = rectan(y, ang3);
		z[m][j] = rectan(y, ang4);
	}
	j=kn;
	for(l = kn; l <= n; l = l + 1){
		z[0][l] = z[0][j];
		z[m][l] = z[m][j];
		j=j-1;
	}
}
/*____________________________________________________*/
float rectan(s,sl)
float s, sl;
{
	float h;
	h = s * tan(sl * (M_PI/180));
	return(h);
}
/*____________________________________________________*/
circles()
{
	int 	i, j;
	float x, y;
	float	cir();

	for(i = 0; i <= m; i = i + 1){
		x= i * d;
		z[i][0] = cir(x, xl);
		z[i][n] = z[i][0];
	}
	for(j = 0; j <= n; j = j + 1){
		y= j * d;
		z[0][j] = cir(y, yl);
		z[m][j] = z[0][j];
	}
}
/*____________________________________________________*/
float cir(s,sl)
float s, sl;
{
	float h;
	h = fabs(sqrt((sl/2)*(sl/2)-(s-sl/2)*(s-sl/2)));
	return(h);
}
/*____________________________________________________*/
ellipse()
{
	int 	i, j;
	float 	x, y;
	float	elips();

	for(i = 0; i <= m; i = i + 1){
		x= i * d;
		z[i][0] = elips(x, xl, hx1);
		z[i][n] = elips(x, xl, hx2);
	}
	
	for(j = 0; j <= n; j = j + 1){
		y = j * d;
		z[0][j] = elips(y, yl, hy1);
		z[m][j] = elips(y, yl, hy2);
	}
}
/*____________________________________________________*/
float elips(s,sl,hm)
float s, sl,hm;
{
	float h;
      	h = sqrt(pow(hm,2.)*(1-(pow((s-sl/2),2.)/pow((sl/2),2.))));
	return(h);
}
/*____________________________________________________*/
usage()
{
	fprintf(stderr,"--------------------------------------------------------------- \n");
	fprintf(stderr,"genshell is a Radiance utility for creating different kinds \n");
	fprintf(stderr,"of membranes\n");
	fprintf(stderr,"Abraham Yezioro, Fac. of Architecture - TECHNION, Israel \n");
	fprintf(stderr,"The algorithm for the calculation of the geometry is based on \n");
	fprintf(stderr,"the master research dveloped by prof. Edna Shaviv in Cornell U. \n");
	fprintf(stderr,"--------------------------------------------------------------- \n");
	fprintf(stderr,"genshell usage:\n");
	fprintf(stderr,"genshell mat name show_type radius xl yl m n type (params...)\n\n");
	fprintf(stderr,"show_type : s - Surfaces, w - wire frame\n");
	fprintf(stderr,"radius    : When show_typw is w (wire frame) this option must get a value\n");
	fprintf(stderr,"            greater than 0. In show_type s (surface) radius value is \n");
	fprintf(stderr,"            irrelevant, however you must give any (0) \n");
	fprintf(stderr,"xl yl     : Lenght and wide of the shell\n");
	fprintf(stderr,"m n       : Number of divisions of the shell (Recomm. an even No.,\n");
	fprintf(stderr,"	    and that m = n)\n");
	fprintf(stderr,"Types are : P, E, C, L, T\n");
	fprintf(stderr,"Parameters according to type:\n");
	fprintf(stderr,"     P (parabole) :  h1 h2 h3 h4 (Heights in the middle of\n");
	fprintf(stderr,"		     each side of the shell\n");
	fprintf(stderr,"     E (ellipse)  :  h1 h2 h3 h4\n");
	fprintf(stderr,"     C (circle)   :  no arguments\n");
	fprintf(stderr,"     L (linear)   :  ang1 ang2 (Inclination angles)\n");
	fprintf(stderr,"     T (triangle) :  ang1 ang2 ang3 ang (Inclination angles for\n");
	fprintf(stderr,"		     each side of the shell)\n\n");
	fprintf(stderr,"Example:\n");
	fprintf(stderr,"To create a wire frame Parabolic membrane of 8 units and 10 divisions\n");
	fprintf(stderr,"each side, and with one side of maximal height in the middle of 5 units\n");
	fprintf(stderr,"and also its opposite (m direction --> x) and the third and fourth sides \n"); 
	fprintf(stderr,"of 10 units height (n direction --> y) looks like this \n");
	fprintf(stderr,"(Notice that the radius value is 0.04):\n\n");
	fprintf(stderr,"genshell red_plastic sh1 w 0.04 8 8 10 10 p 5 5 10 10\n\n\n");
	fprintf(stderr,"For the same membrane, but with show_type surface, the\n");
	fprintf(stderr,"example will look:\n\n");
	fprintf(stderr,"genshell red_plastic sh1 s 0 8 8 10 10 p 5 5 10 10\n\n");
}
